import 'package:flutter/material.dart';
import 'package:flutter_localizations/flutter_localizations.dart';
import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/core/routes/app_router.dart';
import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/gen/app_localizations.dart';
import 'package:{{#snakeCase}}{{project_name}}{{/snakeCase}}/presentation/shared/widgets/flavor_banner.dart';
import 'package:wyatt_bloc_helper/wyatt_bloc_helper.dart';

class App extends StatelessWidget {
  const App({super.key});

  @override
  Widget build(BuildContext context) => MultiProvider(
        // TODO(Wyatt): add global bloc providers here
        child: FlavorBanner(
          child: MaterialApp.router(
            title: '{{#titleCase}}{{display_name}}{{/titleCase}}',
            debugShowCheckedModeBanner: false,
            routerDelegate: AppRouter.routerOf(context).routerDelegate,
            routeInformationParser:
                AppRouter.routerOf(context).routeInformationParser,
            routeInformationProvider:
                AppRouter.routerOf(context).routeInformationProvider,
            localizationsDelegates: const [
              AppLocalizations.delegate,
              GlobalMaterialLocalizations.delegate,
              GlobalWidgetsLocalizations.delegate,
              GlobalCupertinoLocalizations.delegate,
            ],
            supportedLocales: AppLocalizations.supportedLocales,
          ),
        ),
      );
}
