#!/usr/bin/env bash

# Copyright (C) 2023 WYATT GROUP
# Please see the AUTHORS file for details.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <https://www.gnu.org/licenses/>.

# This tool is used to build all bricks.

SCRIPT=$(readlink -f "$0")
SCRIPTPATH=$(dirname "$SCRIPT")

# Go to the brick generator directory
cd $SCRIPTPATH/brick_generator

# Build the brick generator
echo "🍺 Building brick generator"
dart pub get
mkdir -p ./build
dart compile exe ./bin/brickgen.dart -o ./build/brickgen

# Go to the root directory
cd $SCRIPTPATH/..

# List all folders in apps folder
app_lst=$(ls -d ./apps/* | cut -f3 -d'/')

# Build all bricks
for app in $app_lst; do
    # Get the name of the folder
    name=$(basename $app)
    echo "🍺 Building $name"
    # Build the brick
    ./tools/brick_generator/build/brickgen ./apps/$name/ ./bricks/
done
